## hhvm 3.12.11+dfsg

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

# This needs to be done before any languages are enabled or
# projects are created.
INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CMake/VisualStudioToolset.cmake")

# includes
SET(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/CMake" ${CMAKE_MODULE_PATH})
include_directories(${CMAKE_CURRENT_BINARY_DIR})

# package information
SET(PACKAGE_NAME      "hhvm")
SET(PACKAGE_VERSION   "3.12.11")
SET(PACKAGE_STRING    "${PACKAGE_NAME} ${PACKAGE_VERSION}")
SET(PACKAGE_TARNAME   "${PACKAGE_NAME}-${PACKAGE_VERSION}")
SET(PACKAGE_BUGREPORT "https://github.com/facebook/hhvm/issues")

PROJECT(${PACKAGE_NAME} C CXX ASM)
if (MSVC)
  enable_language(ASM_MASM)
endif()

MARK_AS_ADVANCED(CLEAR CMAKE_INSTALL_PREFIX)
IF(APPLE)
  # CMake really likes finding libraries inside OS X frameworks. This can
  # create super unexpected results, such as the LDAP framework, where the
  # ldap.h header there just consists of "#include <ldap.h>" -- obviously
  # assuming /usr/include appears on the include path before that framework
  # (which wasn't really supposed to be on the include path at all). This
  # leads to a hilarious recursive include and general fireworks. Instead,
  # tell CMake to search frameworks *last*, if it doesn't find something in
  # /usr (or MacPorts/Homebrew).
  SET(CMAKE_FIND_FRAMEWORK "LAST")
  MARK_AS_ADVANCED(CMAKE_OSX_ARCHITECTURES
    CMAKE_OSX_DEPLOYMENT_TARGET
    CMAKE_OSX_SYSROOT)
ENDIF()

# Check architecture OS
IF(NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
  MESSAGE(FATAL_ERROR "HHVM requires a 64bit OS")
ENDIF()

# 3rd party library
IF(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/third-party/CMakeLists.txt")
  MESSAGE(FATAL_ERROR "third-party/CMakeLists.txt missing. "
                      "Try updating your submodule with:
rm -r third-party
git submodule update --init --recursive
")
ENDIF()

INCLUDE("${CMAKE_CURRENT_SOURCE_DIR}/CMake/HPHPFunctions.cmake")
INCLUDE(CheckFunctionExists)

SET(HPHP_HOME ${CMAKE_CURRENT_SOURCE_DIR})
SET(TP_DIR "${CMAKE_CURRENT_SOURCE_DIR}/third-party")
SET(TP_BUILD_DIR "${CMAKE_CURRENT_BINARY_DIR}/third-party")

include(MSVCDefaults)

ADD_SUBDIRECTORY(third-party)
ADD_SUBDIRECTORY(hphp)

# use GNU install dirs (e.g. lib64 instead of lib)
INCLUDE(GNUInstallDirs)

# modules / depends
FILE(GLOB HHVM_CMAKE_FILES "CMake/*.cmake")
INSTALL(
  FILES ${HHVM_CMAKE_FILES}
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/hhvm/CMake"
  COMPONENT dev)

=== hphp/hack/CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.7 FATAL_ERROR)

find_package(OCaml)
find_package(LZ4)
find_package(LibElf)
find_package(Memfd)

if (OCAMLC_FOUND)
  # This is totally the wrong way to do this, but I am tired of fighting with
  # build systems and don't really care to make this work the right way. libelf
  # and lz4 are all we need right now anyways.
  unset(extra_include_paths)
  unset(extra_lib_paths)
  unset(extra_cc_flags)

  # Allows '#include "hphp/path/to/library/"' paths to start from hphp
  # project directory  which is consistent with fbmake's include paths.

  IF(HPHP_HOME)
    list(APPEND extra_include_paths ${HPHP_HOME})
  ELSE()
    list(APPEND extra_include_paths ${CMAKE_CURRENT_SOURCE_DIR}/../..)
  ENDIF()

  foreach(lib ${LIBELF_INCLUDE_DIRS})
    list(APPEND extra_include_paths ${lib})
  endforeach()
  if(ELF_GETSHDRSTRNDX)
    list(APPEND extra_cc_flags -DHAVE_ELF_GETSHDRSTRNDX)
  endif()

  if(HAVE_MEMFD_CREATE)
    list(APPEND extra_cc_flags -DHAVE_MEMFD_CREATE)
  endif()

  if(HAVE_DECL___NR_MEMFD_CREATE)
    list(APPEND extra_cc_flags -DHAVE_DECL___NR_MEMFD_CREATE)
  endif()

  list(APPEND extra_cc_flags -DOSS_SMALL_HH_TABLE_POWS)
  list(APPEND extra_cc_flags -pthread)

  foreach(lib ${LIBELF_LIBRARIES})
    get_filename_component(pth ${lib} PATH)
    list(APPEND extra_lib_paths ${pth})
  endforeach()

  if(LZ4_FOUND)
    list(APPEND extra_include_paths ${LZ4_INCLUDE_DIR})
    get_filename_component(pth ${LZ4_LIBRARY} PATH)
    list(APPEND extra_lib_paths ${pth})
  else()
    list(APPEND extra_include_paths "${TP_DIR}/lz4")
    list(APPEND extra_lib_paths "${TP_BUILD_DIR}/lz4")
  endif()
  list(APPEND extra_native_libraries "lz4")

  # Xcode/Ninja generators undefined MAKE
  if(NOT MAKE)
    set(MAKE make)
  endif()

  add_custom_target(
    hack
    ALL
    COMMAND
      env OPTBIN="${OCAMLC_OPT_SUFFIX}"
          $(MAKE) EXTRA_INCLUDE_PATHS="${extra_include_paths}"
          EXTRA_LIB_PATHS="${extra_lib_paths}"
          EXTRA_CC_FLAGS="${extra_cc_flags}"
          EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
  )

  add_custom_target(
    hack_test
    COMMAND
      env OPTBIN="${OCAMLC_OPT_SUFFIX}"
          $(MAKE) test EXTRA_INCLUDE_PATHS="${extra_include_paths}"
          EXTRA_LIB_PATHS="${extra_lib_paths}"
          EXTRA_CC_FLAGS="${extra_cc_flags}"
          EXTRA_NATIVE_LIBRARIES="${extra_native_libraries}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/src"
  )

  if(NOT LZ4_FOUND)
    # if the system does not have lz4, make sure that the one in public_tld
    # gets built
    add_dependencies(hack lz4)
    add_dependencies(hack_test lz4)
  endif()

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_client
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_server
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/hh_format
    DESTINATION bin
    COMPONENT dev)

  install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/bin/h2tp
    DESTINATION bin
    COMPONENT dev)

  install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/src/h2tp/resources/
    DESTINATION share/hhvm/hack/hacklib
    COMPONENT dev)
endif()

=== hphp/util/CMakeLists.txt ===
set(CXX_SOURCES)
auto_sources(files "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND CXX_SOURCES ${files})

set(ASM_SOURCES)
auto_sources(files "*.S" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND ASM_SOURCES ${files})

set(HEADER_SOURCES)
auto_sources(files "*.h" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}")
list(APPEND HEADER_SOURCES ${files})

# Disable Channeled JSON until we're sure it's going to stick
# sgolemon(2014-02-19)
HHVM_REMOVE_MATCHES_FROM_LISTS(ASM_SOURCES CXX_SOURCES HEADER_SOURCES
  MATCHES "/test/" "channeled-json-")

if (NOT MSVC)
  list(REMOVE_ITEM CXX_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strptime.cpp
  )
  list(REMOVE_ITEM HEADER_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/fnmatch.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/glob.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/rand_r.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strfmon.h
    ${CMAKE_CURRENT_SOURCE_DIR}/portability/strptime.h
  )
endif()

HHVM_PUBLIC_HEADERS(util ${HEADER_SOURCES})

add_custom_command(
  OUTPUT "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-repo-schema.h"
         "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-build-info.cpp"
  COMMAND "${CMAKE_CURRENT_SOURCE_DIR}/generate-buildinfo.sh"
  DEPENDS ${CXX_SOURCES}
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/
  COMMENT "Generating Repo Schema ID and Compiler ID"
  VERBATIM)

option(DISABLE_NUMA "Disable NUMA support" OFF)
if (NOT DISABLE_NUMA)
  find_package(LibNuma)
  if (LIBNUMA_INCLUDE_DIRS)
    add_definitions("-DHAVE_NUMA=1")
    include_directories(${LIBNUMA_INCLUDE_DIRS})
  endif()
endif()

if(MSVC)
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/afdt-util.h")
  list(REMOVE_ITEM CXX_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.cpp")
  list(REMOVE_ITEM HEADER_SOURCES "${CMAKE_CURRENT_SOURCE_DIR}/light-process.h")
endif()

add_library(hphp_util STATIC ${CXX_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES}
            "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-repo-schema.h"
            "${CMAKE_CURRENT_SOURCE_DIR}/../hphp-build-info.cpp")
auto_source_group("hphp_util" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${ASM_SOURCES} ${CXX_SOURCES} ${HEADER_SOURCES})
if (ENABLE_COTIRE)
  cotire(hphp_util)
endif()

if (LIBNUMA_LIBRARIES AND JEMALLOC_ENABLED AND NOT DISABLE_NUMA)
  target_link_libraries(hphp_util ${LIBNUMA_LIBRARIES})
endif()
if (ENABLE_ASYNC_MYSQL)
  add_dependencies(hphp_util webscalesqlclient)
endif ()

=== third-party/folly/CMakeLists.txt ===
set(FOLLY_DIR "${CMAKE_CURRENT_SOURCE_DIR}/src/folly")

# Needed for fcntl w/ F_SETPIPE_SZ
add_definitions("-D_GNU_SOURCE")

# Ensure that we are either getting malloc functions
# like malloc_usable_size() from either malloc.h
# or stdlib.h. Default is stdlib.h
INCLUDE(CheckCXXSourceCompiles)
CHECK_CXX_SOURCE_COMPILES("#include <malloc.h>
int main() {
  return 0;
}" FOLLY_MALLOC)
if (FOLLY_MALLOC)
  add_definitions("-DFOLLY_HAVE_MALLOC_H=1")
else()
  add_definitions("-DFOLLY_HAVE_MALLOC_H=0")
endif()

if (NOT EXISTS "${FOLLY_DIR}/Portability.h")
  message(FATAL_ERROR "${FOLLY_DIR}/Portability.h missing, did you forget to "
                      "run `git submodule update --init --recursive`?")
endif()

add_definitions(-DNO_LIB_GFLAGS)

# Generated files from folly/build/generate_*.py
auto_sources(genfiles "*.cpp" "RECURSE" "${CMAKE_CURRENT_SOURCE_DIR}/gen")

# Main folly library files
auto_sources(files "*.cpp" "RECURSE" "${FOLLY_DIR}")
auto_sources(cfiles "*.c" "RECURSE" "${FOLLY_DIR}")

# No need for tests, Benchmarks, Utils, or most experimental stuff
foreach (file ${files})
  if (${file} MATCHES "/test/")
    list(REMOVE_ITEM files ${file})
  endif()
  if (${file} MATCHES "Test.cpp$")
    list(REMOVE_ITEM files ${file})
  endif()
  if (${file} MATCHES "/futures/exercises/")
    list(REMOVE_ITEM files ${file})
  endif()
endforeach()
list(REMOVE_ITEM files
  ${FOLLY_DIR}/Benchmark.cpp
  ${FOLLY_DIR}/build/GenerateFingerprintTables.cpp
  ${FOLLY_DIR}/detail/Clock.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracer.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracerBenchmark.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/ExceptionTracerLib.cpp
  ${FOLLY_DIR}/experimental/exception_tracer/StackTrace.cpp
  ${FOLLY_DIR}/experimental/JSONSchemaTester.cpp
  ${FOLLY_DIR}/experimental/io/AsyncIO.cpp
  ${FOLLY_DIR}/experimental/io/HugePageUtil.cpp
  ${FOLLY_DIR}/experimental/io/IOBufQueue.cpp
  ${FOLLY_DIR}/experimental/RCUUtils.cpp
  ${FOLLY_DIR}/experimental/ProgramOptions.cpp
  ${FOLLY_DIR}/experimental/symbolizer/StackTrace.cpp
  ${FOLLY_DIR}/experimental/symbolizer/ElfCache.cpp
  ${FOLLY_DIR}/experimental/symbolizer/ElfUtil.cpp
  ${FOLLY_DIR}/experimental/symbolizer/SignalHandler.cpp
  ${FOLLY_DIR}/experimental/TestUtil.cpp
  ${FOLLY_DIR}/SingletonStackTrace.cpp
  )

CHECK_CXX_SOURCE_COMPILES("#include <bits/functexcept.h>
int main() {
  return 0;
}" FOLLY_FUNCTEXCEPT)
if (FOLLY_FUNCTEXCEPT)
  list(REMOVE_ITEM files
    ${FOLLY_DIR}/detail/FunctionalExcept.cpp
  )
endif()

# Remove non-portable items
if (NOT LINUX)
  list(REMOVE_ITEM files
    ${FOLLY_DIR}/experimental/symbolizer/Symbolizer.cpp
    ${FOLLY_DIR}/experimental/symbolizer/Dwarf.cpp
    ${FOLLY_DIR}/experimental/symbolizer/Elf.cpp
    )
endif()

# io/Compression requires snappy library
# Don't add dep until we need it
list(REMOVE_ITEM files ${FOLLY_DIR}/io/Compression.cpp)

add_library(folly STATIC ${files} ${genfiles} ${cfiles} )

find_package(Boost 1.51.0 COMPONENTS system program_options filesystem regex
             context REQUIRED)
include_directories(${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

find_package(Glog REQUIRED)
include_directories(${LIBGLOG_INCLUDE_DIR})

find_package(PThread REQUIRED)
include_directories(${LIBPTHREAD_INCLUDE_DIRS})

target_link_libraries(folly ${Boost_LIBRARIES}
                            ${LIBGLOG_LIBRARY}
                            ${LIBPTHREAD_LIBRARIES})

if (DOUBLE_CONVERSION_LIBRARY)
  target_link_libraries(folly ${DOUBLE_CONVERSION_LIBRARY})
else()
  target_link_libraries(folly double-conversion)
endif()

if (JEMALLOC_ENABLED)
  target_link_libraries(folly ${JEMALLOC_LIB})
endif()

# For some reason we aren't making a folly-config.h and this is in there.
# Please fix properly!
add_definitions("-DFOLLY_VERSION=\"0.1\"")

=== hphp/hack/src/Makefile ===
################################################################################
#                            Variables to override                             #
################################################################################

EXTRA_INCLUDE_PATHS=
EXTRA_LIB_PATHS=
EXTRA_CC_FLAGS=

################################################################################
#                              OS-dependent stuff                              #
################################################################################

OS=$(shell uname -s)
ROOT=$(shell pwd)

ifeq ($(OS), Linux)
  INOTIFY=third-party/inotify
  FSNOTIFY=fsnotify_linux
  ELF=elf
  FRAMEWORKS=
  SECTCREATE=
endif
ifeq ($(OS), Darwin)
  INOTIFY=fsevents
  FSNOTIFY=fsnotify_darwin
  ELF=
  FRAMEWORKS=CoreServices CoreFoundation
  SECTCREATE=-cclib -sectcreate -cclib __text -cclib hhi -cclib $(ROOT)/../bin/hhi.tar.gz
endif

################################################################################
#                                 Definitions                                  #
################################################################################

MODULES=\
  client\
  deps\
  dfind\
  emitter\
  find\
  format\
  globals\
  h2tp/common\
  h2tp/mapper\
  h2tp/test\
  h2tp/unparser\
  h2tp\
  heap\
  hh_matcher\
  hh_matcher/test\
  hhi\
  libancillary\
  naming\
  parsing\
  procs\
  search\
  server\
  socket\
  stubs\
  third-party/avl\
  third-party/core\
  typing\
  utils\
  monitor\
  watchman\
  $(FSNOTIFY)\
  $(INOTIFY)

NATIVE_OBJECT_FILES=\
  heap/hh_shared.o\
  hhi/hhi_elf.o\
  hhi/hhi_win32res_stubs.o\
  libancillary/libancillary-stubs.o\
  third-party/libancillary/fd_recv.o\
  third-party/libancillary/fd_send.o\
  utils/files.o\
  utils/get_build_id.gen.o\
  utils/get_build_id.o\
  utils/handle_stubs.o\
  utils/nproc.o\
  utils/priorities.o\
  utils/realpath.o\
  utils/sysinfo.o\
  utils/win32_support.o\
  $(INOTIFY)/$(notdir $(INOTIFY))_stubs.o

OCAML_LIBRARIES=\
  str\
  unix\
  bigarray

NATIVE_LIBRARIES=\
  pthread\
  $(ELF)

TARGETS=_build/hh_server.native _build/hh_client.native \
		_build/hh_single_type_check.native _build/hh_emitter.native \
		_build/hh_format.native _build/h2tp.native _build/test_unparser.native \
		_build/hh_match.native \
		_build/code_extent_tests.native \
		_build/matcher_test.native \
		_build/patcher_api_test.native \
		_build/patcher_module_test.native \
		_build/patcher_test.native

# Find all source files (all files not in _build dir)
ALL_SRC_FILES=$(call rwildcard,$(patsubst _build,,$(wildcard *)),*.*)

################################################################################
#                                    Rules                                     #
################################################################################

INCLUDE_OPTS=$(foreach dir,$(MODULES),-I $(dir))
LIB_OPTS=$(foreach lib,$(OCAML_LIBRARIES),-lib $(lib))
NATIVE_LIB_OPTS=$(foreach lib, $(NATIVE_LIBRARIES),-cclib -l$(lib))
EXTRA_NATIVE_LIB_OPTS=$(foreach lib, $(EXTRA_NATIVE_LIBRARIES),-cclib -l$(lib))
EXTRA_INCLUDE_OPTS=$(foreach dir, $(EXTRA_INCLUDE_PATHS),-ccopt -I$(dir))
EXTRA_CC_OPTS=$(foreach opt, $(EXTRA_CC_FLAGS),-ccopt $(opt))
EXTRA_LIB_OPTS=$(foreach dir, $(EXTRA_LIB_PATHS),-cclib -L$(dir))
FRAMEWORK_OPTS=$(foreach framework, $(FRAMEWORKS),-cclib -framework -cclib $(framework))

LINKER_FLAGS=$(NATIVE_OBJECT_FILES) $(NATIVE_LIB_OPTS) $(EXTRA_LIB_OPTS) \
	     $(EXTRA_NATIVE_LIB_OPTS) $(FRAMEWORK_OPTS) $(SECTCREATE)
# Function to recursively find files, eg: $(call rwildcard,dir/to/look/in/,*.c)
rwildcard=$(wildcard $1$2) $(foreach d,$(wildcard $1*),$(call rwildcard,$d/,$2))

all: build-hhi-archive build-hack copy-hack-files
all-ocp: build-hhi-archive build-hack-with-ocp copy-hack-files-ocp

clean:
	ocamlbuild -clean
	find ../bin -mindepth 1 -not -path ../bin/README -delete
	rm -f utils/get_build_id.gen.c

build-hack: $(TARGETS) build-hhi-archive

build-hack-with-ocp: build-hhi-archive build-hack-stubs-with-ocp
	[ -d ${ROOT}/../_obuild ] || ( cd ${ROOT}/.. && ocp-build init )
	ocp-build build

# All targets are built in one time, so no parallelization is necessary
.NOTPARALLEL: $(TARGETS)
# As there is no efficient way to calculate the dependencies of
# the targets, we make them dependent on all files. In doing this
# we ensure that no rebuild is necessary if nothing has changed
$(TARGETS): $(ALL_SRC_FILES)
	# build-hack-native-deps is a dependency of $(TARGETS) but as it is phony
	# we place it here to avoid unnecessary rebuilds
	$(MAKE) build-hack-native-deps build-hhi-archive
	ocamlbuild -no-links -cflag -g $(INCLUDE_OPTS) $(LIB_OPTS) \
		-lflags "-g $(LINKER_FLAGS)" \
		$(patsubst _build/%,%,$(TARGETS))
	# Touching the targets is necessary because the ocaml build
	# doesn't change the modification dates of the targets if
	# the new binaries are exactly the same as the old ones
	touch $(TARGETS)

build-hack-native-deps: build-hack-stubs
	ocamlbuild -cflags "-g $(EXTRA_INCLUDE_OPTS) $(EXTRA_CC_OPTS)" $(NATIVE_OBJECT_FILES)

# If you modify this rule, do not forget to edit the file
# `$(ROOT)/scripts/gen_build_id.ml` used on Windows.
build-hack-stubs:
	REV="const char* const BuildInfo_kRevision = \"$$(git rev-parse HEAD || hg id -i)\";"; \
	if [ "$$REV" != "$$(cat utils/get_build_id.gen.c 2>/dev/null)" ]; then echo "$$REV" > utils/get_build_id.gen.c; fi

build-hack-stubs-with-ocp:
	cd $(ROOT)/.. && \
        ocaml unix.cma scripts/gen_build_id.ml src/utils/get_build_id.gen.c

build-hhi-archive:
	mkdir -p ../bin
	$(MAKE) -C ../hhi

copy-hack-files: build-hack
	mkdir -p ../bin
ifeq ($(OS), Linux)
	objcopy --add-section hhi=../bin/hhi.tar.gz _build/hh_server.native ../bin/hh_server
else
	cp _build/hh_server.native ../bin/hh_server
endif
	cp _build/hh_client.native ../bin/hh_client
	cp _build/hh_single_type_check.native ../bin/hh_single_type_check
	cp _build/hh_emitter.native ../bin/hh_emitter
	cp _build/hh_format.native ../bin/hh_format
	cp _build/h2tp/h2tp.native ../bin/h2tp
	cp _build/hh_match.native ../bin/hh_match

copy-hack-files-ocp: build-hack-with-ocp
	mkdir -p ../bin
ifeq ($(OS), Linux)
	objcopy --add-section hhi=../bin/hhi.tar.gz ../_obuild/hh_server/hh_server.asm ../bin/hh_server
else
	cp ../_obuild/hh_server/hh_server.asm ../bin/hh_server
endif
	cp ../_obuild/hh_client/hh_client.asm ../bin/hh_client
	cp ../_obuild/hh_single_type_check/hh_single_type_check.asm ../bin/hh_single_type_check
	cp ../_obuild/hh_format/hh_format.asm ../bin/hh_format
	cp ../_obuild/h2tp/h2tp.asm ../bin/h2tp
	cp ../_obuild/hh_match/hh_match.asm ../bin/hh_match

copy-match-test-files:
	mkdir -p ../bin
	cp _build/hh_matcher/test/code_extent_tests.native \
		../bin/code_extent_test_driver
	cp _build/hh_matcher/test/matcher_test.native \
		../bin/hh_match_test_driver
	cp _build/hh_matcher/test/patcher_module_test.native \
		../bin/hh_patch_module_test_driver
	cp _build/hh_matcher/test/patcher_api_test.native \
		../bin/hh_patch_api_test_driver
	cp _build/hh_matcher/test/patcher_test.native \
		../bin/hh_patch_test_driver

copy-match-test-files-ocp:
	mkdir -p ../bin
	cp ../_obuild/code_extent_tests/code_extent_tests.asm \
		../bin/code_extent_test_driver
	cp ../_obuild/matcher_test/matcher_test.asm \
		../bin/hh_match_test_driver
	cp ../_obuild/patcher_module_test/patcher_module_test.asm \
		../bin/hh_patch_module_test_driver
	cp ../_obuild/patcher_api_test/patcher_api_test.asm \
		../bin/hh_patch_api_test_driver
	cp ../_obuild/patcher_test/patcher_test.asm \
		../bin/hh_patch_test_driver

.PHONY: test test-ocp do-test
test: build-hack copy-hack-files copy-match-test-files
	${MAKE} do-test

test-ocp: build-hack-with-ocp copy-hack-files-ocp copy-match-test-files-ocp
	${MAKE} do-test

do-test:
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/autocomplete
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/color
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/colour
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/coverage
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/dumpsymbolinfo
	python3 ../test/verify.py --program ../bin/hh_format ../test/format
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/suggest
	python3 ../test/verify.py --program ../bin/hh_single_type_check ../test/typecheck
	python3 ../test/verify.py --program ../bin/hh_format ../test/typecheck \
		--disabled-extension .no_format \
		--out-extension .format_out \
		--expect-extension '' \
		--flags --root .
	python3 ../test/verify.py --program ../bin/code_extent_test_driver ../test/hh_matcher/code_extent
	python3 ../test/verify.py --program ../bin/hh_match_test_driver ../test/hh_matcher/matcher_tests
	python3 ../test/verify.py --program ../bin/hh_patch_module_test_driver ../test/hh_matcher/patcher_module_tests
	python3 ../test/verify.py --program ../bin/hh_patch_api_test_driver ../test/hh_matcher/patcher_api_tests
	python3 ../test/verify.py --program ../bin/hh_patch_test_driver ../test/hh_matcher/patcher_tests
	python3 ../test/integration/runner.py ../bin/hh_server ../bin/hh_client

=== hphp/runtime/ext_zend_compat/CMakeLists.txt ===
INCLUDE(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(ENABLE_MONGO
  "Enable Mongo extension (requires ENABLE_ZEND_COMPAT)" OFF
  "ENABLE_ZEND_COMPAT" OFF)
CMAKE_DEPENDENT_OPTION(ENABLE_EZC_TEST
  "Enable ezc_test (requires ENABLE_ZEND_COMPAT)" OFF "ENABLE_ZEND_COMPAT" OFF)

set(CXX_SOURCES)
set(C_SOURCES)
set(ASM_SOURCES)
set(HEADER_SOURCES)
set(ZEND_COMPAT_LINK_LIBRARIES)
set(PHP_SOURCES)
set(EZC_DIR ${CMAKE_CURRENT_SOURCE_DIR})
HHVM_SELECT_SOURCES("${EZC_DIR}/php-src")
HHVM_SELECT_SOURCES("${EZC_DIR}/hhvm")

include_directories("${EZC_DIR}/php-src")
include_directories("${EZC_DIR}/php-src/main")
include_directories("${EZC_DIR}/php-src/Zend")
include_directories("${EZC_DIR}/php-src/TSRM")

if (ENABLE_ZEND_COMPAT)
  macro(auto_systemlib DIR)
    auto_sources(files "*.php" RECURSE ${DIR})
    foreach(f ${files})
      list(APPEND PHP_SOURCES ${f})
    endforeach()
  endmacro()

  set(ZEND_COMPAT_PROJECTS)
  # Look for projects
  file(GLOB ezc_projects RELATIVE ${EZC_DIR} "${EZC_DIR}/*")
  foreach(ezc_project ${ezc_projects})
    get_filename_component(ezc_name ${ezc_project} NAME)
    #
    # The subdirectory dso_test is built using hphpize,
    # and is NOT statically linked into hhvm.
    # It is intended to be loaded as a DSO during test.
    #
    if ((NOT ${ezc_name} STREQUAL "dso_test") AND
        (NOT ${ezc_name} STREQUAL "php-src") AND
        (NOT ${ezc_name} STREQUAL "hhvm") AND
        (IS_DIRECTORY "${EZC_DIR}/${ezc_name}"))
      list(APPEND ZEND_COMPAT_PROJECTS ${ezc_name})
    endif()
  endforeach()

  foreach(ezc_project ${ZEND_COMPAT_PROJECTS})
    if (${ezc_project} STREQUAL "yaml")
      find_package(LibYaml)
      if (LibYaml_INCLUDE_DIRS)
        HHVM_SELECT_SOURCES("${EZC_DIR}/yaml")
        include_directories(${LibYaml_INCLUDE_DIRS})
        list(APPEND ZEND_COMPAT_LINK_LIBRARIES ${LibYaml_LIBRARIES})
        auto_systemlib("${EZC_DIR}/yaml")
      endif()
    elseif (${ezc_project} STREQUAL "mongo")
      if (ENABLE_MONGO)
        message(WARNING "The ext_zend_compat version of the MongoDB extension is deprecated. Please use the official driver at https://github.com/mongodb/mongo-hhvm-driver instead.")
        HHVM_SELECT_SOURCES("${EZC_DIR}/mongo")
        include_directories("${EZC_DIR}/mongo/mcon")
        auto_systemlib("${EZC_DIR}/mongo")
      endif()
    elseif (${ezc_project} STREQUAL "ezc_test")
      if (ENABLE_EZC_TEST)
        HHVM_SELECT_SOURCES("${EZC_DIR}/ezc_test")
        auto_systemlib("${EZC_DIR}/ezc_test")
      endif()
    else()
      HHVM_SELECT_SOURCES("${EZC_DIR}/${ezc_project}")
      auto_systemlib("${EZC_DIR}/${ezc_project}")
    endif()
  endforeach()

endif()
set(EZC_SYSTEMLIB_SOURCES ${PHP_SOURCES} CACHE INTERNAL "" FORCE)

add_library(hphp_ext_zend_compat STATIC ${CXX_SOURCES} ${C_SOURCES}
            ${ASM_SOURCES} ${HEADER_SOURCES})
auto_source_group("hphp_ext_zend_compat" "${CMAKE_CURRENT_SOURCE_DIR}"
  ${CXX_SOURCES} ${C_SOURCES} ${ASM_SOURCES} ${HEADER_SOURCES})
if (ZEND_COMPAT_LINK_LIBRARIES)
  target_link_libraries(hphp_ext_zend_compat ${ZEND_COMPAT_LINK_LIBRARIES})
endif()
hphp_link(hphp_ext_zend_compat)

HHVM_PUBLIC_HEADERS(ext_zend_compat ${HEADER_SOURCES})

include(dso_test/dso_test.cmake)

=== debian/changelog ===
hhvm (3.12.11+dfsg-1build2) artful; urgency=medium

  * No-change rebuild against libevent-2.1-6

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 31 Jul 2017 02:41:28 +0000

hhvm (3.12.11+dfsg-1build1) zesty; urgency=medium

  * Rebuild against new OCaml ABI.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Mon, 16 Jan 2017 20:54:32 +0530

hhvm (3.12.11+dfsg-1) unstable; urgency=medium

  [ Moritz Muehlenhoff ]
  * New upstream LTS releases, addressing multiple security issues.
    (Closes: #835032)
    From 3.12.2:
     - CVE-2015-8865 - Buffer overwrite in finfo_open with malformed magic
     - Integer overflow in iptcembed
     - CVE-2016-3074 - Fix signedness issue in libgd
     - CVE-2014-9709 - Fix a possible buffer read overflow in gd_gif_in.cpp
     - Prevent a potential nullptr dereference in ext_xsl
     - Don't segfault if you try to remove the last autoloader while
       adding a new one
     - CVE-2016-1903 - imagerotate information leak
     - FILTER_FLAG_STRIP_BACKTICK` was being ignored unless other flags
       are set
     - CVE-2016-4539 - Fix a segfault in xml_parse_into_struct
     - Fix a potential null dereference in ZipArchive::extractTo
     - CVE-2016-4070 - Integer Overflow in php_raw_url_encode
    From 3.12.3:
     - CVE-2016-1000004 - Type safety in simplexml import routines
     - CVE-2016-1000004 - Fix param types for mcrypt_get_block_size()
       to match PHP
     - CVE-2016-1000006 - Fix use-after-free in
       serialize_memoize_param() and ResourceBundle::__construct()
     - CVE-2016-6870 - Use req::strndup in php_mb_parse_encoding_list to
       prevent oob memory write.
     - HHVM-2016-11781481 - Fix nullptr dereference in
       f_mysqli_stmt_bind{param,result}
     - HHVM-2016-11791940 - Avoid invalid array access in JSON_decode()
     - PHP-2016-0072337 - Fix a segfault with invalid dimensions and
       imagescale out of bounds read in ext_gd
    From 3.12.5:
     - CVE-2016-1000109: Ignore Proxy HTTP header from fastcgi requests
    From 3.12.6:
     - CVE-2016-6871 - Fix buffer overrun due to integer overflow in bcmath
     - CVE-2016-6872 - Fix integer overflow in StringUtil::implode
     - CVE-2016-6873 - Fix self recursion in compact
     - CVE-2016-6874 - Fix recursion checks in array_*_recursive
     - CVE-2016-6875 - Fix infinite recursion in wddx
     - PHP-2015-0070345 - [HHVM][Security] 0003 pcre preg bug 70345
    From 3.12.8:
     - ext_gd: exif_process_IFD_TAG: Use the right offset if reading from
       stream
     - Fix some color related crashes in libgd
     - Don't allow smart_str to overflow int
     - Integer overflow in _gd2GetHeader
     - Fix objprof refcounting
     - Fix buffer overruns in mb_send_mail
     - Integer overflow in gdImagePaletteToTrueColor
     - Null pointer dereference in _gdScaleVert
     - pass2_no_dither out-of-bounds access
    From 3.12.9:
     - Fix off-by-one index check in ThreadSafeLocaleHandler::actuallySetLocale
     - Prevent an integer overflow in _gdContributionsAlloc
     - Fix a potential overflow in tsrm_virtual_file_ex
     - Invalid transparent index can result in OOB read or write
     - Do not treat negative return values from bz2 as size_t
     - Fix OOB read in exif_process_IFD_in_MAKERNOTE
     - Prevent an OOB access in locale_accept_from_http
     - Avoid possible OOB using imagegif
     - Disable bad zend test
     - Add an option to explicitly disable NUMA support.
    From 3.12.10:
     - Fix a bug in StringUtil::Explode
     - Fix a couple of bugs in libgd
    From 3.12.11:
     - Prevent integer overflow in gdImageWebpCtx
     - Check depth values in json_decode
     - Prevent negative gamma values being passed to imagegammacorrect
     - Fix crypt with over-long salts
     - Memory leak in exif_process_IFD_in_TIFF
     - 9da Fix getimagesize returning FALSE on valid jpg

  [ Faidon Liambotis ]
  * Build against libmysqlclient, not libmysqlclient_r. Thanks to Robie Basak
    for the bug report and patch. (Closes: #825077)
  * Build-Depend on default-libmysqlclient-dev instead of libmysqlclient-dev.
    (Closes: #845852)
  * Add /bin/sh shebangs on maintainer scripts. (Closes: #843281)
  * Remove update-alternatives --remove from postrm, already included in prerm
    (and also causes a lintian warning).
  * Remove David Martínez Moreno from the Uploaders, at the request of the MIA
    team. (Closes: #843439)
  * Fix FTBFS with GCC 6, by backporting an upstream fix. (Closes: #812023)
  * Pass -fno-PIE/-no-pie to gcc to prevent a linking error with GCC 6's new
    configuration (--enable-default-pie) in combination with HHVM's
    hand-crafted assembly (translator-asm-helpers.S).
  * Build-Depend on libssl1.0-dev, as HHVM is not ready for OpenSSL 1.1.0 yet.
    (Closes: #828340)
  * Remove Build-Depends on libc-client2007e-dev and thus disable the IMAP
    extension. libc-client2007e-dev depends on libssl-dev 1.1.0, which
    conflicts with libssl1.0-dev and is thus impossible to satisfy.
  * Disable Folly's Fibers, as the current version is incompatible with Boost
    1.61 and thus FTBFS. The incompatibility has been fixed upstream but is
    too intrusive to backport, thus disable the functionality entirely.
    (Closes: #839303)
  * Temporarily disable the mcrouter extension as it requires Folly Fibers,
    that were disabled in this version (see above).
  * Backport an upstream fix to address an ICU Collation sort key
    incompatibility with PHP.
  * Backport an upstream fix to address a segfault when bzip2 and XMLReader
    are being used together.
  * Backport an upstream fix to address inconsistent regexp results when
    running with a newer PCRE version (8.38 instead of 8.32).
  * Disable test pcre_limit.php which now fails for unknown reasons;
    upstream seemingly has disabled the test as well for a while with no ill
    effects.
  * Add a Documentation line to the systemd service file.
  * Bump Standards-Version to 3.9.8, no changes needed.



=== debian/control ===
Source: hhvm
Section: php
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian HHVM packaging team <pkg-hhvm-team@lists.alioth.debian.org>
Uploaders: Faidon Liambotis <paravoid@debian.org>
Build-Depends: debhelper (>= 9.0.0),
  autotools-dev,
  binutils-dev,
  bison,
  chrpath,
  cmake,
  default-libmysqlclient-dev | libmysqlclient-dev,
  flex,
  gawk,
  gperf,
  libboost-dev,
  libboost-context-dev,
  libboost-filesystem-dev,
  libboost-program-options-dev,
  libboost-regex-dev,
  libboost-system-dev,
  libboost-thread-dev,
  libbz2-dev,
  libcap-dev,
# Depends on libssl-dev, which conflicts with libssl1.0
# libc-client2007e-dev,
  libcurl4-openssl-dev,
  libdouble-conversion-dev,
  libdwarf-dev,
  libedit-dev,
  libelf-dev,
  libevent-dev,
  libexpat1-dev,
  libfreetype6-dev,
  libgmp-dev,
  libgoogle-glog-dev,
  libiberty-dev,
  libicu-dev,
  libinotifytools0-dev,
  libjemalloc-dev,
  libjpeg-dev,
  libjson-c-dev,
  libldap2-dev,
  liblz4-dev,
  libmagickcore-dev,
  libmagickwand-dev,
  libmcrypt-dev,
  libmemcached-dev,
  libonig-dev,
  libpcre3-dev,
  libpng-dev,
  libre2-dev,
  libsqlite3-dev,
  libssl1.0-dev | libssl-dev (<< 1.1.0~),
  libtbb-dev,
  libvpx-dev,
  libxml2-dev,
  libxslt1-dev,
  libyaml-dev,
  libzip-dev (>= 0.11),
  ocaml-native-compilers,
  pkg-config,
  unixodbc-dev,
  zlib1g-dev
Standards-Version: 3.9.8
Homepage: http://hhvm.com/
Vcs-Git: https://anonscm.debian.org/git/pkg-hhvm/hhvm.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-hhvm/hhvm.git

Package: hhvm
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}
Provides: ${hhvm:ApiVersion}
Description: HipHop Virtual Machine, a JIT replacement for PHP - main runtime
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.

Package: hhvm-dbg
Architecture: amd64
Depends: hhvm (= ${binary:Version}), python, ${misc:Depends}
Recommends: gdb
Section: debug
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - debugging symbols
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the debugging symbols for HHVM.

Package: hhvm-dev
Architecture: amd64
Depends: ${misc:Depends}, cmake
Section: libdevel
Priority: extra
Description: HipHop Virtual Machine, a JIT replacement for PHP - development files
 HHVM is an open-source virtual machine designed for executing programs
 written in Hack and PHP. HHVM uses a just-in-time (JIT) compilation
 approach to achieve superior performance while maintaining the development
 flexibility that PHP provides.
 .
 For the majority of your programs HHVM should be a drop-in replacement for
 the usual PHP interpreter/engine.
 .
 This package provides the header & build system files needed for compiling
 HHVM extensions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

#export DH_VERBOSE=1

# To prevent bogus linkage.
LDFLAGS += -Wl,--as-needed

# avoid FTBFS with GCC 6 due to translator-asm-helpers.S not being PIC
# might be fixed with commit 8b6c9f4 in HHVM 3.14
ifneq ($(shell $(CC) -dumpspecs 2>/dev/null | grep -e no-pie),)
  CFLAGS  += -fno-pie
  LDFLAGS += -no-pie
endif

# used to store HHBC during tests
BUILDHOME = $(CURDIR)/debian/build

# Exported variable to make sure that we don't use cursor control in the tests.
export TRAVIS = bogus

# Contrary to its confusing name, this is actually the build's revision ID.
# hphp/util/generate-buildinfo.sh uses:
#   $COMPILER_ID -> git describe -> hg log -> date
# We want to avoid relying on git (because we may building from the .dsc) and
# date (because that would add variance to the build)
export COMPILER_ID = $(shell dpkg-parsechangelog -SVersion)

# same with the repo schema, which uniquely identifies a build; the script
# takes some variance into account, possibly from CMakeFiles; it also operates
# differently when under git, so make it just a hash of the Debian version.
export HHVM_REPO_SCHEMA = $(shell dpkg-parsechangelog -SVersion | sha1sum | cut -b-40)

%:
	dh $@ --parallel

override_dh_auto_build:
	# rerun flex/bison to regenerate their output for DFSG reasons
	./hphp/parser/make-lexer.sh
	./hphp/parser/make-parser.sh
	VERBOSE=1 dh_auto_build

override_dh_auto_configure:
	printenv
	echo $(LDFLAGS)
	dh_auto_configure -- \
		-DUSE_JSONC=ON \
		-DFREETYPE_INCLUDE_DIRS=/usr/include/freetype2/ \
		-DENABLE_MCROUTER=OFF \
		-DENABLE_ASYNC_MYSQL=OFF \
		-DMYSQL_UNIX_SOCK_ADDR=/dev/null \
		-DCMAKE_INSTALL_PREFIX=/usr \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test:
	# HHVM by default uses ~/.hhvm.hhbc, but ~ isn't guranteed to exist.
	-mkdir $(BUILDHOME)
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m jit quick
	HOME=$(BUILDHOME) hphp/hhvm/hhvm hphp/test/run -m interp quick
endif

override_dh_clean:
	dh_clean
	-rm -rf $(BUILDHOME)

override_dh_gencontrol:
	# see hphp/runtime/version.h, HHVM_VERSION_BRANCH
	hhvmapi=$(shell $(CURDIR)/debian/hhvm/usr/bin/hhvm --version | sed -ne 's/^HipHop VM \(.*\)\..*/\1/p') && \
		[ -n "$${hhvmapi}" ] && echo "hhvm:ApiVersion=hhvm-api-$${hhvmapi}" >> debian/hhvm.substvars
	dh_gencontrol

override_dh_strip:
	dh_strip --dbg-package=hhvm-dbg

override_dh_fixperms:
	dh_fixperms
	chown www-data:www-data \
		$(CURDIR)/debian/hhvm/var/cache/hhvm
